=== debian/changelog ===
trace-cmd (2.8.3-7build1) groovy; urgency=medium

  * No change rebuild against new json-c ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 28 Jul 2020 17:48:38 +0100

trace-cmd (2.8.3-7) unstable; urgency=medium

  * Update compat level to 13.
  * Fix FTBFS with gcc-10. (Closes: #957879)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 15 May 2020 23:42:36 +0100

trace-cmd (2.8.3-6) unstable; urgency=medium

  * Fix SIGSEGV with Kernelshark. (Closes: #955527)
  * Use secure copyright format uri.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 14 Apr 2020 19:16:58 +0100

trace-cmd (2.8.3-5) unstable; urgency=medium

  * Remove dependency on cdbs.
  * Update Standards-Version to 4.5.0.
  * Add a missing build dependency.
    - kernelshark was unable to capture trace.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 29 Feb 2020 20:02:10 +0000

trace-cmd (2.8.3-4) unstable; urgency=medium

  * Add dependency for mipsel

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 25 Dec 2019 18:59:32 +0000

trace-cmd (2.8.3-3) unstable; urgency=medium

  * Fix FTCBFS, thanks to Helmut Grohne. (Closes: #946296)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 22 Dec 2019 22:43:33 +0000

trace-cmd (2.8.3-2) unstable; urgency=medium

  * build should be verbose by default (Closes: #946067)
  * Add the watch file

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 04 Dec 2019 21:32:41 +0000

trace-cmd (2.8.3-1) unstable; urgency=medium

  * Update to upstream v2.8.3 and change maintainer (Closes: #943551)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 04 Nov 2019 12:44:42 +0000
